package com.its.vms;

import com.its.app.AppUtils;
import com.its.app.utils.OS;
import com.its.app.utils.SysUtils;
import com.its.vms.config.ApplicationConfig;
import com.its.vms.entity.TbUnitSyst;
import com.its.vms.process.DbmsDataProcess;
import com.its.vms.service.*;
import com.its.vms.ui.JTextAreaOutputStream;
import com.its.vms.ui.MainUI;
import com.its.vms.xnettcp.center.CenterTcpServerService;
import com.its.vms.xnettcp.vms.VmsTcpCommServerService;
import com.its.vms.xnettcp.vms.process.TcpServerRecvDataProcess;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.DisposableBean;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.boot.Banner;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.boot.context.ApplicationPidFileWriter;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationListener;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.event.ContextClosedEvent;
import org.springframework.core.io.ClassPathResource;
import org.springframework.scheduling.annotation.EnableAsync;

import javax.swing.*;
import java.awt.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.lang.reflect.Field;
import java.net.URL;
import java.nio.charset.Charset;

@Slf4j
@EnableAsync
@Configuration
@SpringBootApplication
@ComponentScan(basePackages = {"com.its.vms.config", "com.its.vms.dao.mapper", "com.its"})
public class VmsCommServerApplication implements CommandLineRunner, ApplicationListener<ContextClosedEvent>, InitializingBean, DisposableBean {

    private static String applicationName = "vms-comm-server";

    public static void main(String[] args) {
        System.setProperty("file.encoding","UTF-8");
        try {
            Field charset = Charset.class.getDeclaredField("defaultCharset");
            charset.setAccessible(true);
            charset.set(null,null);
        } catch(Exception e){
        }

        File file1 = new File("./conf/" + applicationName + ".pid");
        if (file1.exists()) {
            System.out.println(System.getProperty("Program Already Running....."));
            log.error("Program Already Running.....");
        }

        if (OS.isWindows()) {
            ApplicationContext context = new SpringApplicationBuilder(VmsCommServerApplication.class)
                    //.web(WebApplicationType.NONE)
                    .listeners(new ApplicationPidFileWriter("./conf/" + applicationName + ".pid"))
                    .headless(false)
                    .bannerMode(Banner.Mode.OFF)
                    .run(args);
        } else {
            SpringApplication application = new SpringApplicationBuilder()
                    .sources(VmsCommServerApplication.class)
                    .listeners(new ApplicationPidFileWriter("./conf/" + applicationName + ".pid"))
                    .build();
            application.setBannerMode(Banner.Mode.OFF);
            application.run(args);
        }
    }

    @Override
    public void run(String... args) throws Exception {
        if (OS.isWindows()) {
            String sysTime = SysUtils.getSysTimeStr();
            //JFrame.setDefaultLookAndFeelDecorated(true);
            JFrame frame = new JFrame("VMS 통신 서버 - [" + sysTime + "]");
            MainUI UI = new MainUI(frame);
            SwingUtilities.invokeLater(() -> {
                try {
                    ClassPathResource file = new ClassPathResource("static/image/application.png");
                    URL imgURL = file.getURL();
                    frame.setIconImage(new ImageIcon(imgURL).getImage());
                } catch (IOException e) {
                    log.error("Not found application icon image");
                }
                frame.setModalExclusionType(Dialog.ModalExclusionType.APPLICATION_EXCLUDE);
                frame.setContentPane(UI.getRootPanel());
                frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                frame.addWindowListener(new WindowAdapter() {
                    @Override
                    public void windowClosing(WindowEvent e) {
                        if (JOptionPane.showConfirmDialog(UI.getRootPanel(), "VMS 통신서버 프로그램을 종료 하시겠습니까?", "프로그램 종료", 0) == 0) {
                            System.exit(0);
                        } else {
                            frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
                        }
                    }
                });
                frame.pack();
                frame.setBounds(100, 100, 900, 600);
                frame.setLocationRelativeTo(null);
                frame.setVisible(true);

                JTextArea logArea = UI.getTaLog();
                logArea.setText(null);
                JTextAreaOutputStream out = new JTextAreaOutputStream(logArea);
                System.setOut(new PrintStream(out));
            });
        }

        ApplicationConfig applicationConfig = (ApplicationConfig) AppUtils.getBean(ApplicationConfig.class);

        log.info("");
        log.info("");
        log.info("************************************************************************************");
        log.info("**                                                                                **");
        log.info("**                         Intelligent Traffic System                             **");
        log.info("**                      VMS Communication Server Program.                         **");
        log.info("**                                                                                **");
        log.info("**                                                                   [ver.1.0]    **");
        log.info("**          {}", applicationConfig.getId());
        log.info("** startup: {}", applicationConfig.getBootingDateTime());
        log.info("************************************************************************************");

        // init application
        DbmsDataProcess dbmsDataProcess = (DbmsDataProcess)AppUtils.getBean(DbmsDataProcess.class);
        dbmsDataProcess.run();

        TcpServerRecvDataProcess tcpServerRecvDataProcess = (TcpServerRecvDataProcess)AppUtils.getBean(TcpServerRecvDataProcess.class);
        tcpServerRecvDataProcess.run();

        UnitSystService unitSystService = (UnitSystService)AppUtils.getBean(UnitSystService.class);
        unitSystService.loadMaster();
        unitSystService.updateUnitSystStts(true);
        TbUnitSyst unit = unitSystService.getDataMap().get(applicationConfig.getId());
        if (unit != null) {
            applicationConfig.setListenPort(unit.getPrgmPort());
        }

        VmsCtlrService ctlrService = (VmsCtlrService)AppUtils.getBean(VmsCtlrService.class);
        ctlrService.loadDb();
        ctlrService.updateCtlrStts(true, null);

        VmsFontService vmsFontService = (VmsFontService)AppUtils.getBean(VmsFontService.class);
        vmsFontService.loadDb();

        VmsIfscService vmsIfscService = (VmsIfscService)AppUtils.getBean(VmsIfscService.class);
        vmsIfscService.loadDb();

        if (OS.isWindows()) {
            MainUI UI = MainUI.getInstance();
            if (UI != null) {
                UI.loadControllerInfo();
            }
        }

        VmsSymbService vmsSymbService = (VmsSymbService)AppUtils.getBean(VmsSymbService.class);
        vmsSymbService.loadDb();
        vmsSymbService.loadVmsSymbLibDnld();
        vmsSymbService.loadVmsScheSymbLib();

        VmsAtmpService vmsAtmpService = (VmsAtmpService)AppUtils.getBean(VmsAtmpService.class);
        vmsAtmpService.loadDb();

        VmsFormService vmsFormService = (VmsFormService)AppUtils.getBean(VmsFormService.class);
        vmsFormService.loadDb();

        VmsManageService vmsManageService = (VmsManageService)AppUtils.getBean(VmsManageService.class);
        vmsManageService.initVmsDsplPrst();
        vmsManageService.jobMakeDownloadVmsForm();

        // VMS Communication Service Start.........
        VmsTcpCommServerService vmsTcpCommServerService = (VmsTcpCommServerService)AppUtils.getBean(VmsTcpCommServerService.class);
        vmsTcpCommServerService.run();

        CenterTcpServerService centerService = (CenterTcpServerService)AppUtils.getBean(CenterTcpServerService.class);
        centerService.run();

        // schedule enable
        applicationConfig.setStartSchedule(true);
    }

    public void terminateApplication() {
        UnitSystService unitSystService = (UnitSystService) AppUtils.getBean(UnitSystService.class);
        unitSystService.updateUnitSystStts(false);
        VmsCtlrService ctlrService = (VmsCtlrService) AppUtils.getBean(VmsCtlrService.class);
        ctlrService.updateCtlrStts(false, null);

        CenterTcpServerService centerService = (CenterTcpServerService)AppUtils.getBean(CenterTcpServerService.class);
        centerService.stop();

        VmsTcpCommServerService vmsTcpCommServerService = (VmsTcpCommServerService)AppUtils.getBean(VmsTcpCommServerService.class);
        vmsTcpCommServerService.stop();
    }
    @Override
    public void onApplicationEvent(ContextClosedEvent event) {
        log.error("Application Terminated: {}", event.getTimestamp());
        terminateApplication();
    }
    @Override
    public void afterPropertiesSet() throws Exception {
    }
    @Override
    public void destroy() throws Exception {
    }

}
